/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/usr/diag/attn/test/attntest.C $                           */
/*                                                                        */
/* IBM CONFIDENTIAL                                                       */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2012,2013              */
/*                                                                        */
/* p1                                                                     */
/*                                                                        */
/* Object Code Only (OCO) source materials                                */
/* Licensed Internal Code Source Materials                                */
/* IBM HostBoot Licensed Internal Code                                    */
/*                                                                        */
/* The source code for this program is not published or otherwise         */
/* divested of its trade secrets, irrespective of what has been           */
/* deposited with the U.S. Copyright Office.                              */
/*                                                                        */
/* Origin: 30                                                             */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/**
 * @file attntest.C
 *
 * @brief HBATTN test utility function definitions.
 */

#include <arch/ppc.H>
#include <algorithm>
#include "attntest.H"
#include "../attntrace.H"
#include "../attntarget.H"

using namespace std;
using namespace PRDF;
using namespace TARGETING;

namespace ATTN
{

uint64_t randint(uint64_t i_min, uint64_t i_max)
{
    static bool setup = false;
    static uint64_t seed = 0;

    if(!setup)
    {
        uint64_t hapSeed = generate_random();

        if(!hapSeed)
        {
            ATTN_DBG("falling back to timebase seed for PRNG");
        }
        else
        {
            ATTN_DBG("hapseed: %d", hapSeed);
        }

        seed = hapSeed ? hapSeed : getTB() + 1;

        setup = true;
    }

    uint64_t lo, hi;

    seed = seed * seed;
    lo = (seed & 0x0000ffffffff0000ull) >> 16;
    hi = (seed & 0x000000000000ffffull) << 32;
    hi |= (seed & 0xffff000000000000ull);
    seed = (lo | hi) + 2;

    static const uint64_t randMax = 0xfffffffffffffffe;
    uint64_t min = i_min, max = i_max;

    if(i_min > i_max)
    {
        swap(min, max);
    }

    if(max > randMax)
    {
        max = randMax;
    }

    return ((lo | hi) % (max +1 - min)) + min;
}

ATTENTION_VALUE_TYPE getRandomAttentionType()
{
    ATTENTION_VALUE_TYPE a;

    switch (randint(1, 3))
    {
        case 2:
            a = RECOVERABLE;
            break;
        case 3:
        default:
            a = SPECIAL;
            break;
    };

    return a;
}
}
